Package org.eclipse.ui

# Class ExtensionFactory

java.lang.Object
org.eclipse.ui.ExtensionFactory

All Implemented Interfaces:
  `IExecutableExtension`, `IExecutableExtensionFactory`

public class ExtensionFactory extends Object implements IExecutableExtensionFactory, IExecutableExtension
Factory for the workbench's public extensions.

This allows the extensions to be made available for use by RCP applications without exposing their concrete implementation classes.

Since:
  3.1

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`APPEARANCE_PREFERENCE_PAGE`
Factory ID for the Appearance preference page.
`static final String`
`COLORS_AND_FONTS_PREFERENCE_PAGE`
Factory ID for the Colors and Fonts preference page.
`static final String`
`CONTENT_TYPES_PREFERENCE_PAGE`
Factory ID for the ContentTypes preference page.
`static final String`
`DECORATORS_PREFERENCE_PAGE`
Factory ID for the Decorators preference page.
`static final String`
`EDITORS_PREFERENCE_PAGE`
Factory ID for the Editors preference page.
`static final String`
`FILE_ASSOCIATIONS_PREFERENCE_PAGE`
Factory ID for the File Associations preference page.
`static final String`
`KEYS_PREFERENCE_PAGE`
Factory ID for the Keys preference page.
`static final String`
`NEW_KEYS_PREFERENCE_PAGE`
Factory ID for the new (and improved) keys preference page.
`static final String`
`PERSPECTIVES_PREFERENCE_PAGE`
Factory ID for the Perspectives preference page.
`static final String`
`PREFERENCES_EXPORT_WIZARD`
Factory ID for the Preferences export wizard.
`static final String`
`PREFERENCES_IMPORT_WIZARD`
Factory ID for the Preferences import wizard.
`static final String`
`PROGRESS_VIEW`
Factory ID for the Progress view.
`static final String`
`SHOW_IN_CONTRIBUTION`
Factory ID for the show in contribution.
`static final String`
`WORKBENCH_PREFERENCE_PAGE`
Factory ID for the Workbench preference page.

## Constructor Summary

Constructors
Constructor
Description
`ExtensionFactory()`
Constructs a new workbench extension factory.

## Method Summary

Modifier and Type
Method
Description
`Object`
`create()`
Creates the object referenced by the factory id obtained from the extension data.
`void`
`setInitializationData(IConfigurationElement config, String propertyName, Object data)`
This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### APPEARANCE_PREFERENCE_PAGE

public static final String APPEARANCE_PREFERENCE_PAGE
Factory ID for the Appearance preference page.

See Also:
  - Constant Field Values

### COLORS_AND_FONTS_PREFERENCE_PAGE

public static final String COLORS_AND_FONTS_PREFERENCE_PAGE
Factory ID for the Colors and Fonts preference page.

See Also:
  - Constant Field Values

### DECORATORS_PREFERENCE_PAGE

public static final String DECORATORS_PREFERENCE_PAGE
Factory ID for the Decorators preference page.

See Also:
  - Constant Field Values

### EDITORS_PREFERENCE_PAGE

public static final String EDITORS_PREFERENCE_PAGE
Factory ID for the Editors preference page.

See Also:
  - Constant Field Values

### FILE_ASSOCIATIONS_PREFERENCE_PAGE

public static final String FILE_ASSOCIATIONS_PREFERENCE_PAGE
Factory ID for the File Associations preference page.

See Also:
  - Constant Field Values

### KEYS_PREFERENCE_PAGE

public static final String KEYS_PREFERENCE_PAGE
Factory ID for the Keys preference page.

See Also:
  - Constant Field Values

### NEW_KEYS_PREFERENCE_PAGE

public static final String NEW_KEYS_PREFERENCE_PAGE
Factory ID for the new (and improved) keys preference page.

Since:
  3.2
See Also:
  - Constant Field Values

### PERSPECTIVES_PREFERENCE_PAGE

public static final String PERSPECTIVES_PREFERENCE_PAGE
Factory ID for the Perspectives preference page.

See Also:
  - Constant Field Values

### PREFERENCES_EXPORT_WIZARD

public static final String PREFERENCES_EXPORT_WIZARD
Factory ID for the Preferences export wizard.

See Also:
  - Constant Field Values

### PREFERENCES_IMPORT_WIZARD

public static final String PREFERENCES_IMPORT_WIZARD
Factory ID for the Preferences import wizard.

See Also:
  - Constant Field Values

### PROGRESS_VIEW

public static final String PROGRESS_VIEW
Factory ID for the Progress view.

See Also:
  - Constant Field Values

### WORKBENCH_PREFERENCE_PAGE

public static final String WORKBENCH_PREFERENCE_PAGE
Factory ID for the Workbench preference page.

See Also:
  - Constant Field Values

### CONTENT_TYPES_PREFERENCE_PAGE

public static final String CONTENT_TYPES_PREFERENCE_PAGE
Factory ID for the ContentTypes preference page.

See Also:
  - Constant Field Values

### SHOW_IN_CONTRIBUTION

public static final String SHOW_IN_CONTRIBUTION
Factory ID for the show in contribution.

Since:
  3.4
See Also:
  - Constant Field Values

## Constructor Details

### ExtensionFactory

public ExtensionFactory()
Constructs a new workbench extension factory.

## Method Details

### create

public Object create() throws CoreException
Creates the object referenced by the factory id obtained from the extension data.

Specified by:
  `create` in interface `IExecutableExtensionFactory`
Throws:
  `CoreException` - if an instance of the executable extension could not be created for any reason

### setInitializationData

public void setInitializationData(IConfigurationElement config, String propertyName, Object data) throws CoreException
Description copied from interface: `IExecutableExtension`
This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information. Most executable extensions only make use of the first two call arguments.

Regular executable extensions specify their Java implementation class name as an attribute of the configuration element for the extension. For example

         <action run="com.example.BaseAction"/>

In the above example, this method would be called with a reference to the `<action>` element (first argument), and `"run"` as the name of the attribute that defined this executable extension (second argument).

The last parameter is for the specific use of extension adapters and is typically not used by regular executable extensions.

There are two supported ways of associating additional adapter-specific data with the configuration in a way that is transparent to the extension point implementor:

(1) by specifying adapter data as part of the implementation class attribute value. The Java class name can be followed by a ":" separator, followed by any adapter data in string form. For example, if the extension point specifies an attribute `"run"` to contain the name of the extension implementation, an adapter can be configured as

         <action run="com.example.ExternalAdapter:./cmds/util.exe -opt 3"/>

(2) by converting the attribute used to specify the executable extension to a child element of the original configuration element, and specifying the adapter data in the form of xml markup. Using this form, the example above would become

         <action>
             <run class="com.xyz.ExternalAdapter">
                 <parameter name="exec" value="./cmds/util.exe"/>
                 <parameter name="opt"  value="3"/>
             </run>
         </action>

Form (2) will typically only be used for extension points that anticipate the majority of extensions configured into it will in fact be in the form of adapters.

In either case, the specified adapter class is instantiated using its 0-argument public constructor. The adapter data is passed as the last argument of this method. The data argument is defined as Object. It can have the following values:

- `null`, if no adapter data was supplied
- in case (1), the initialization data string is passed as a `String`
- in case (2), the initialization data is passed as a `Hashtable` containing the actual parameter names and values (both `String`s)

Specified by:
  `setInitializationData` in interface `IExecutableExtension`
Parameters:
  `config` - the configuration element used to trigger this execution. It can be queried by the executable extension for specific configuration properties
  `propertyName` - the name of an attribute of the configuration element used on the `createExecutableExtension(String)` call. This argument can be used in the cases where a single configuration element is used to define multiple executable extensions.
  `data` - adapter data in the form of a `String`, a `Hashtable`, or `null`.
Throws:
  `CoreException` - if error(s) detected during initialization processing
See Also:
  - `IConfigurationElement.createExecutableExtension(String)`